/* Custumizable code for events/actuators/sensors */
/*     Generated by Code_Generation toolbox of Scicos with scicos4.4 */
/*     date : 20-Oct-2010 */

/* Copyright (c) 1989-2010 Metalau project INRIA */

/* ---- Headers ---- */
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>

/* ---- File ptrs declaration to read/write signals data ----*/
FILE *fprr_1,*fprw_1;

/*----------------------------------------  External events handling function */
void SuperBlock_events(int *nevprt,double *t)
{
/*  set next event time and associated events ports
 *  nevprt has binary expression b1..b1 where bi is a bit
 *  bi is set to 1 if an activation is received by port i. Note that
 *  more than one activation can be received simultaneously
 *  Caution: at least one bi should be equal to one */

    int i,p,b[]={0};

/* this is an example for the activation of events ports */
    b[0]=1;

/* definition of the step time  */
    *t = *t + 0.1;

/* External events handling process */
    *nevprt=0;p=1;
    for (i=0;i<1;i++) {
      *nevprt=*nevprt+b[i]*p;
      p=p*2;
    }
}
/*---------------------------------------- Actuators */
void SuperBlock_actuator(flag,nport,nevprt,t,u,nu1,nu2,ut,typout,outptr)
     /*
      * To be customized for standalone execution
      * flag   : specifies the action to be done
      * nport  : specifies the  index of the super-block
      *          regular input (The input ports are numbered
      *          from the top to the bottom )
      * nevprt : indicates if an activation had been received
      *          0 = no activation
      *          1 = activation
      * t      : the current time value
      * u      : the vector inputs value
      * nu1    : the input size 1
      * nu2    : the input size 2
      * ut     : the input type
      * typout : learn mode (0 from terminal,1 from input file)
      * outptr : pointer to out data
      *          typout=0, outptr not used
      *          typout=1, outptr contains the output file name
      */
     int *flag,*nevprt,*nport;
     int *nu1,*nu2,*ut;

     int typout;
     void *outptr;

     double *t;
     void *u;
{
  int j,k,l;
  char *file_str;
  char buf[1024];
  if (typout == 0) { /* terminal */
    /* skeleton to be customized */
    switch (*flag) {
    case 4 : /* actuator initialisation */
      /* do whatever you want to initialize the actuator */
      break;
    case 2 :
      /*if(*nevprt>0) { print the input value */
        switch (*ut) {
        case 10 :
          for (l=0;l<*nu2;l++) {
            for (k=0;k<*nu1;k++) {
              printf("Actuator: time=%f, u(%d,%d) of actuator %d is %f \n", \
                     *t, k, l, *nport,*((double *) u+(k+l*(*nu1))));
            }
          }
          break;

        case 11 :
          for (l=0;l<*nu2;l++) {
            for (k=0;k<*nu1;k++) {
              printf("Actuator: time=%f, u(%d,%d) of actuator %d is %f,%f \n", \
                     *t, k, l, *nport,*((double *) u+(k+l*(*nu1))),*((double *) u+((*nu1)*(*nu2)+k+l*(*nu1))));
            }
          }
          break;

        case 81 :
          for (l=0;l<*nu2;l++) {
            for (k=0;k<*nu1;k++) {
              printf("Actuator: time=%f, u(%d,%d) of actuator %d is %i \n", \
                     *t, k, l, *nport,*((char *) u+(k+l*(*nu1))));
            }
          }
          break;

        case 82 :
          for (l=0;l<*nu2;l++) {
            for (k=0;k<*nu1;k++) {
              printf("Actuator: time=%f, u(%d,%d) of actuator %d is %hd \n", \
                     *t, k, l, *nport,*((short *) u+(k+l*(*nu1))));
            }
          }
          break;

        case 84 :
          for (l=0;l<*nu2;l++) {
            for (k=0;k<*nu1;k++) {
              printf("Actuator: time=%f, u(%d,%d) of actuator %d is %ld \n", \
                     *t, k, l, *nport,*((long *) u+(k+l*(*nu1))));
            }
          }
          break;

        case 811 :
          for (l=0;l<*nu2;l++) {
            for (k=0;k<*nu1;k++) {
              printf("Actuator: time=%f, u(%d,%d) of actuator %d is %d \n", \
                     *t, k, l, *nport,*((unsigned char *) u+(k+l*(*nu1))));
            }
          }
          break;

        case 812 :
          for (l=0;l<*nu2;l++) {
            for (k=0;k<*nu1;k++) {
              printf("Actuator: time=%f, u(%d,%d) of actuator %d is %hu \n", \
                     *t, k, l, *nport,*((unsigned short *) u+(k+l*(*nu1))));
            }
          }
          break;

        case 814 :
          for (l=0;l<*nu2;l++) {
            for (k=0;k<*nu1;k++) {
              printf("Actuator: time=%f, u(%d,%d) of actuator %d is %lu \n", \
                     *t, k, l, *nport,*((unsigned long *) u+(k+l*(*nu1))));
            }
          }
          break;
        }
      /*} */
      break;
    case 5 : /* actuator ending */
      /* do whatever you want to end the actuator */
      break;
    }
  }
  else if (typout == 1) { /* file */
    /* skeleton to be customized */
    switch (*flag) {
    case 4 : /* actuator initialisation */
      /* use of seprate files for actuators */
      file_str = (char *) outptr;
      l = 0;

      /* look at for an extension */
      for(k=strlen(file_str);k>=0;k--) {
        if (file_str[k] == '.') {
          l = k;
          break;
         }
       }

       /* if an extension is found, then add suffixe just before */
       if (l !=0 ) {
         j = 0;
         for (k=0;k<l;k++) {
           buf[j] = file_str[k];
           j++;
         }
         buf[j] = '_';
         j++;
         buf[j] = '\0';
         sprintf(buf,"%s%d",buf,*nport);
         strcat(buf,&file_str[l]);
       }
       else {
         sprintf(buf,"%s_%d",file_str,*nport);
       }

      /* open file */
      fprw_1 = fopen(buf,"wt");
      if( fprw_1 == NULL ) {
        fprintf(stderr,"Error opening file: %s\n", buf);
        /* internal error */
        *flag=-3;
        return;
      }
      break;
    case 2 : /* fprintf the input value */
      /*if(*nevprt>0) {*/
        /* write time */
        fprintf(fprw_1,"%f ",*t);

        switch (*ut) {
        case 10 :
          for (l=0;l<*nu2;l++) {
            for (k=0;k<*nu1;k++) {
              fprintf(fprw_1,"%f ", \
                           *((double *) u+(k+l*(*nu1))));
            }
          }
          fprintf(fprw_1,"\n");
          break;

        case 11 :
          for (l=0;l<*nu2;l++) {
            for (k=0;k<*nu1;k++) {
              fprintf(fprw_1,"%f " \
                           "%f ", \
                           *((double *) u+(k+l*(*nu1))), \
                           *((double *) u+((*nu1)*(*nu2)+k+l*(*nu1))));
            }
          }
          fprintf(fprw_1,"\n");
          break;

        case 81 :
          for (l=0;l<*nu2;l++) {
            for (k=0;k<*nu1;k++) {
              fprintf(fprw_1,"%i ", \
                           *((char *) u+(k+l*(*nu1))));
            }
          }
          fprintf(fprw_1,"\n");
          break;

        case 82 :
          for (l=0;l<*nu2;l++) {
            for (k=0;k<*nu1;k++) {
              fprintf(fprw_1,"%hd ", \
                           *((short *) u+(k+l*(*nu1))));
            }
          }
          fprintf(fprw_1,"\n");
          break;

        case 84 :
          for (l=0;l<*nu2;l++) {
            for (k=0;k<*nu1;k++) {
              fprintf(fprw_1,"%ld ", \
                           *((long *) u+(k+l*(*nu1))));
            }
          }
          fprintf(fprw_1,"\n");
          break;

        case 811 :
          for (l=0;l<*nu2;l++) {
            for (k=0;k<*nu1;k++) {
              fprintf(fprw_1,"%d \n", \
                           *((unsigned char *) u+(k+l*(*nu1))));
            }
          }
          fprintf(fprw_1,"\n");
          break;

        case 812 :
          for (l=0;l<*nu2;l++) {
            for (k=0;k<*nu1;k++) {
              fprintf(fprw_1,"%hu ", \
                           *((unsigned short *) u+(k+l*(*nu1))));
            }
          }
          fprintf(fprw_1,"\n");
          break;

        case 814 :
          for (l=0;l<*nu2;l++) {
            for (k=0;k<*nu1;k++) {
              fprintf(fprw_1,"%lu ", \
                           *((unsigned long *) u+(k+l*(*nu1))));
            }
          }
          fprintf(fprw_1,"\n");
          break;
        }
      /*} */
      break;
    case 5 : /* actuator ending */
      fclose(fprw_1);
      break;
    }
  }
}
/*---------------------------------------- Sensors */
void SuperBlock_sensor(flag,nport,nevprt,t,y,ny1,ny2,yt,typin,inptr)
     /*
      * To be customized for standalone execution
      * flag  : specifies the action to be done
      * nport : specifies the  index of the super-block
      *         regular input (The input ports are numbered
      *         from the top to the bottom )
      * nevprt: indicates if an activation had been received
      *         0 = no activation
      *         1 = activation
      * t     : the current time value
      * y     : the vector outputs value
      * ny1   : the output size 1
      * ny2   : the output size 2
      * yt    : the output type
      * typin : learn mode (0 from terminal,1 from input file)
      * inptr : pointer to out data
      *          typin=0, inptr not used
      *          typin=1, inptr contains the input file name
      */
     int *flag,*nevprt,*nport;
     int *ny1,*ny2,*yt;

     int typin;
     void *inptr;

     double *t;
     void *y;
{
  int j,k,l;
  double temps;
  char *file_str;
  char buf[1024];
  if (typin == 0) {
    /* skeleton to be customized */
    switch (*flag) {
    case 4 : /* sensor initialisation */
      /* do whatever you want to initialize the sensor */
      break;
    case 1 : /* set the output value */
      printf("Require outputs of sensor number %d\n", *nport);
      printf("time is: %f\n", *t);
      printf("sizes of the sensor output is: %d,%d\n", *ny1,*ny2);
      switch (*yt) {
      case 10 :
        printf("type of the sensor output is: %d (double) \n", *yt);
        puts("Please set the sensor output values");
        for (l=0;l<*ny2;l++) {
          for (k=0;k<*ny1;k++) {
            printf("y(%d,%d) : ",k,l);
            scanf("%lf", (double *) y+(k+l*(*ny1)));
          }
        }
        break;

      case 11 :
        printf("type of the sensor output is: %d (complex) \n", *yt);
        puts("Please set the sensor output values");
        for (l=0;l<*ny2;l++) {
          for (k=0;k<*ny1;k++) {
            printf("y(%d,%d) real part : ",k,l);
            scanf("%lf", (double *) y+(k+l*(*ny1)));
            printf("y(%d,%d) imag part : ",k,l);
            scanf("%lf", (double *) y+((*ny1)*(*ny2)+k+l*(*ny1)));
          }
        }
        break;

      case 81 :
        printf("type of the sensor output is: %d (char) \n", *yt);
        puts("Please set the sensor output values");
        for (l=0;l<*ny2;l++) {
          for (k=0;k<*ny1;k++) {
            printf("y(%d,%d) : ",k,l);
            scanf("%i", &j);
            *((char *) y+(k+l*(*ny1))) = (char) j;
          }
        }
        break;

      case 82 :
        printf("type of the sensor output is: %d (char) \n", *yt);
        puts("Please set the sensor output values");
        for (l=0;l<*ny2;l++) {
          for (k=0;k<*ny1;k++) {
            printf("y(%d,%d) : ",k,l);
            scanf("%hd", (short *) y+(k+l*(*ny1)));
          }
        }
        break;

      case 84 :
        printf("type of the sensor output is: %d (long) \n", *yt);
        puts("Please set the sensor output values");
        for (l=0;l<*ny2;l++) {
          for (k=0;k<*ny1;k++) {
            printf("y(%d,%d) : ",k,l);
            scanf("%ld", (long *) y+(k+l*(*ny1)));
          }
        }
        break;

      case 811 :
        printf("type of the sensor output is: %d (unsigned char) \n", *yt);
        puts("Please set the sensor output values");
        for (l=0;l<*ny2;l++) {
          for (k=0;k<*ny1;k++) {
            printf("y(%d,%d) : ",k,l);
            scanf("%d", &j);
            *((unsigned char *) y+(k+l*(*ny1))) = (unsigned char) j;
          }
        }
        break;

      case 812 :
        printf("type of the sensor output is: %d (unsigned short) \n", *yt);
        puts("Please set the sensor output values");
        for (l=0;l<*ny2;l++) {
          for (k=0;k<*ny1;k++) {
            printf("y(%d,%d) : ",k,l);
            scanf("%hu", (unsigned short *) y+(k+l*(*ny1)));
          }
        }
        break;

      case 814 :
        printf("type of the sensor output is: %d (unsigned long) \n", *yt);
        puts("Please set the sensor output values");
        for (l=0;l<*ny2;l++) {
          for (k=0;k<*ny1;k++) {
            printf("y(%d,%d) : ",k,l);
            scanf("%lu", (unsigned long *) y+(k+l*(*ny1)));
          }
        }
        break;

      }
      break;
    case 5 : /* sensor ending */
      /* do whatever you want to end the sensor */
      break;
    }
  } 
  else if (typin == 1) {
    /* skeleton to be customized */
    switch (*flag) {
    case 4 : /* sensor initialisation */
      /* use separate files for sensors */
      file_str = (char *) inptr;
      l = 0;

      /* look at for an extension */
      for(k=strlen(file_str);k>=0;k--) {
        if (file_str[k] == '.') {
          l = k;
          break;
         }
       }

       /* if an extension is found, then add suffixe just before */
       if (l !=0 ) {
         j = 0;
         for (k=0;k<l;k++) {
           buf[j] = file_str[k];
           j++;
         }
         buf[j] = '_';
         j++;
         buf[j] = '\0';
         sprintf(buf,"%s%d",buf,*nport);
         strcat(buf,&file_str[l]);
       }
       else {
         sprintf(buf,"%s_%d",file_str,*nport);
       }

      /* open file */
      fprr_1 = fopen(buf,"r");
      if( fprr_1 == NULL ) {
        fprintf(stderr,"Error opening file: %s\n", buf);
        /* internal error */
        *flag=-3;
        return;
      }
      break;
    case 1 : /* fscanf the output value */
    /*if(*nevprt>0) {*/
      /* read time */
      fscanf(fprr_1,"%lf ",&temps);

      switch (*yt) {
      case 10 :
        for (l=0;l<*ny2;l++) {
          for (k=0;k<*ny1;k++) {
            fscanf(fprr_1,"%lf ", \
                        (double *) y+(k+l*(*ny1)));
          }
        }
        fscanf(fprr_1,"\n");
        break;

      case 11 :
        for (l=0;l<*ny2;l++) {
          for (k=0;k<*ny1;k++) {
            fscanf(fprr_1,"%lf " \
                        "%lf ", \
                        (double *) y+(k+l*(*ny1)), \
                        (double *) y+((*ny1)*(*ny2)+k+l*(*ny1)));
          }
        }
        fscanf(fprr_1,"\n");
        break;

      case 81 :
        for (l=0;l<*ny2;l++) {
          for (k=0;k<*ny1;k++) {
            fscanf(fprr_1,"%i ", \
                        &j);
            *((char *) y+(k+l*(*ny1))) = (char) j;
          }
        }
        fscanf(fprr_1,"\n");
        break;

      case 82 :
        for (l=0;l<*ny2;l++) {
          for (k=0;k<*ny1;k++) {
            fscanf(fprr_1,"%hd ", \
                        (short *) y+(k+l*(*ny1)));
          }
        }
        fscanf(fprr_1,"\n");
        break;

      case 84 :
        for (l=0;l<*ny2;l++) {
          for (k=0;k<*ny1;k++) {
            fscanf(fprr_1,"%ld ", \
                        (long *) y+(k+l*(*ny1)));
          }
        }
        fscanf(fprr_1,"\n");
        break;

      case 811 :
        for (l=0;l<*ny2;l++) {
          for (k=0;k<*ny1;k++) {
            fscanf(fprr_1,"%d ", &j);
            *((unsigned char *) y+(k+l*(*ny1))) = (unsigned char) j;
          }
        }
        fscanf(fprr_1,"\n");
        break;

      case 812 :
        for (l=0;l<*ny2;l++) {
          for (k=0;k<*ny1;k++) {
            fscanf(fprr_1,"%hu ", \
                        (unsigned short *) y+(k+l*(*ny1)));
          }
        }
        fscanf(fprr_1,"\n");
        break;

      case 814 :
        printf("type of the sensor output is: %d (unsigned long) \n", *yt);
        puts("Please set the sensor output values");
        for (l=0;l<*ny2;l++) {
          for (k=0;k<*ny1;k++) {
            fscanf(fprr_1,"%lu ", \
                        (unsigned long *) y+(k+l*(*ny1)));
          }
        }
        fscanf(fprr_1,"\n");
        break;
      }
    /*} */
      break;
    case 5 : /* sensor ending */
      fclose(fprr_1);
      /* do whatever you want to end the sensor */
      break;
    }
  }
}
