/* Code prototype for standalone use  */
/*     Generated by Code_Generation toolbox of Scicos with scicos4.4 */
/*     date : 20-Oct-2010 */

/* Copyright (c) 1989-2010 Metalau project INRIA */

/* To learn how to use the standalone code, type "./standalone -h" */

/* ---- Headers ---- */
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#ifdef __STDC__
#include <stdarg.h>
#else
#include <varargs.h>
#endif
#include <memory.h>
#include "scicos_block4.h"
#include "machine.h"

/* ---- Internals functions and global variables declaration ---- */

/* prototype of 'signum' (type 4 - with zcross) */
void signum(scicos_block *, int );

/* prototype of 'summation' (type 4) */
void summation(scicos_block *, int );

/* prototype of 'sawtth' (type 0) */
void C2F(sawtth)(int *, int *, double *, double *, double *, int *, double *, \
                 int *, double *, int *, double *, int *,int *, int *, \
                 double *, int *, double *, int *);

/* prototype of 'gainblk' (type 4) */
void gainblk(scicos_block *, int );

/* prototype of 'actuator' */
void SuperBlock_actuator(int *, int *, int *, double *, void *, \
                         int *, int *, int *, int, void *);

/* prototype of 'sensor' */
void SuperBlock_sensor(int *, int *, int *, double *, void *, \
                       int *, int *, int *, int, void *);

/* prototype for input simulation function */
int SuperBlock_sim(double, double, double, int, \
                  int *, void **, int *, void **);

/* ----  Prototype for cosend function ----  */
int SuperBlock_cosend();

/* ---- Specific declaration for the main() function ---- */
int getopt (int, char **, char *);
static int optind = 1;
static void usage(char *);

/* def phase sim variable */
int phase;

/* a variable for the current time */
double scicos_time;

/* block_error must be pass in argument of _sim function */
int *block_error;
char err_msg[2048];

/* block_number */
int block_number;

/* prototype of error table function */
void get_err_msg(int ierr,char *err_msg);

/* declaration of scicos block structures */
scicos_block block_SuperBlock[6];

/* Main program */
int main(int argc, char *argv[])
{
  /* local variables */
  char input[50],output[50];
  char **p=NULL;

  /* default values for parameters of _sim function */
  double tf=30;         /* final time */
  double dt=0.1;        /* clock time */
  double h=0.001;       /* solver step */
  int solver=1;         /* type of solver */
  /* Inputs of sensors */
  int nin=1;
  int typin[]={0};
  void *inptr[]={0};
  /* Outputs of actuators */
  int nout=1;
  int typout[]={0};
  void *outptr[]={0};
  /**/
  char * progname = argv[0];
  /* local counter variable */
  int c,i;
  /* error handling variable */
  int ierr;

  /* init in/output files */
  strcpy(input,"");
  strcpy(output,"");

  /* check rhs args */
  while ((c = getopt(argc , argv, "i:o:d:t:e:s:hv")) != -1)
    switch (c) {
    case 'i':
      strcpy(input,argv[optind-1]);
      break;
    case 'o':
      strcpy(output,argv[optind-1]);
      break;
    case 'd':
      dt=strtod(argv[optind-1],p);
      break;
    case 't':
      tf=strtod(argv[optind-1],p);
      break;
    case 'e':
      h=strtod(argv[optind-1],p);
      break;
    case 's':
      solver=(int) strtod(argv[optind-1],p);
      break;
    case 'h':
      usage(progname);
      return 0;
      break;
    case 'v':
      printf("Generated by Code_Generation toolbox of Scicos "
             "with scicos4.4\n");
      return 0;
      break;
    case '?':
      usage(progname);
      return 0;
      break;
    }

  /* adjust in/out of sensors/actuators */
  if (strlen(input) > 0) {
    for(i=0;i<nin;i++) {
      typin[i]= 1;
      inptr[i]= (void *) input;
    }
  }
  if (strlen(output)> 0) {
    for(i=0;i<nout;i++) {
      typout[i]= 1;
      outptr[i]= (void *) output;
    }
  }

  /* call simulation function */
  ierr=SuperBlock_sim(tf,dt,h,solver,typin,inptr,typout,outptr);

  /* display error message */
  if (ierr!=0) {
    get_err_msg(ierr,err_msg);
    fprintf(stderr,"Simulation fails with error number %d :\n%s\n",ierr,err_msg);
  }

  return ierr;
}

/* Error table function */
void get_err_msg(int ierr,char *err_msg)
{
  switch (ierr)
  {
   case 1  : strcpy(err_msg,"scheduling problem");
             break;

   case 2  : strcpy(err_msg,"input to zero-crossing stuck on zero");
             break;

   case 3  : strcpy(err_msg,"event conflict");
             break;

   case 4  : strcpy(err_msg,"algrebraic loop detected");
             break;

   case 5  : strcpy(err_msg,"cannot allocate memory");
             break;

   case 6  : strcpy(err_msg,"a block has been called with input out of its domain");
             break;

   case 7  : strcpy(err_msg,"singularity in a block");
             break;

   case 8  : strcpy(err_msg,"block produces an internal error");
             break;

   case 10 : break;

   /* other scicos error should be done */

   default : strcpy(err_msg,"undefined error");
             break;
  }
}

static void usage(prog)
       char *prog;
{
  fprintf(stderr, "Usage: %s [-h] [-v] [-i arg] [-o arg] "
                  "[-d arg] [-t arg] [-e arg] [-s arg]\n", prog);
  fprintf(stderr, "Options : \n");
  fprintf(stderr, "     -h for the help  \n");
  fprintf(stderr, "     -v for printing the Scicos version \n");
  fprintf(stderr, "     -i for input file name, by default is Terminal \n");
  fprintf(stderr, "     -o for output file name, by default is Terminal \n");
  fprintf(stderr, "     -d for the clock period, by default is 0.1 \n");
  fprintf(stderr, "     -t for the final time, by default is 30 \n");
  fprintf(stderr, "     -e for the solvers step size, by default is 0.001 \n");
  fprintf(stderr, "     -s integer parameter for select the numerical solver : \n");
  fprintf(stderr, "        1 for Euler's method \n");
  fprintf(stderr, "        2 for Heun's method \n");
  fprintf(stderr, "        3 (default value) for the Fourth-Order Runge-Kutta (RK4) Formula \n");
}

/*----------------------------------------  External simulation function */
int SuperBlock_sim(tf,dt,h,solver,typin,inptr,typout,outptr)

   double tf,dt,h;
   int solver;
   int *typin,*typout;
   void **inptr,**outptr;
{
  double t;
  int nevprt=1;
  int local_flag;
  int nport;
  int kf;

  /* Variables for constant values */
  int nrd_1, nrd_2;

  double *args[100];

  int err=0;

  /* Initial values */

  /* Real parameters declaration */
  /* Routine name of block: summation
   * Gui name of block: SUMMATION
   * Compiled structure index: 2
   * Exprs: 1
   */
  double rpar_2[]={0};

  /* Routine name of block: gainblk
   * Gui name of block: GAINBLK
   * Compiled structure index: 4
   * Exprs: K_nor
   */
  double rpar_4[]={1000};

  /* Integers parameters declaration */
  /* Routine name of block: summation
   * Gui name of block: SUMMATION
   * Compiled structure index: 2
   * Exprs: 1
   * ipar= {-1,1};
   */
  int ipar_2[]={-1,1};

  /* Routine name of block: actionneur1
   * Gui name of block: OUTPUTPORTEVTS
   * Compiled structure index: 5
   * Exprs: 1
   * ipar= {1};
   */
  int ipar_5[]={1};

  /* Routine name of block: capteur1
   * Gui name of block: INPUTPORTEVTS
   * Compiled structure index: 6
   * Exprs: 1
   * ipar= {1};
   */
  int ipar_6[]={1};

  /* Routine name of block: bidon
   * Gui name of block: EVTGEN_f
   * Compiled structure index: 7
   * Exprs: 1
   * ipar= {1};
   */
  int ipar_7[]={1};

  /* Discrete states declaration */
  /* Routine name of block: sawtth
     Gui name of block: SAWTOOTH_f
     Compiled structure index: 3
  */
  double z_3[]={0};

  /* Output declaration */
  double outtb_1[]={0};
  double outtb_2[]={0};
  double outtb_3[]={0};
  double outtb_4[]={0};
  double outtb_5[]={0};

  /* Inputs */
  int insz_1[]={1,1,SCSREAL_N};
  int insz_2[]={1,1,1,1,SCSREAL_N,SCSREAL_N};
  int insz_4[]={1,1,SCSREAL_N};
  int insz_5[]={1,1,SCSREAL_N};

  void *inptr_1[]={0};
  void *inptr_2[]={0,0};
  void *inptr_4[]={0};
  void *inptr_5[]={0};
  void *inptr_6[]={0};

  /* Outputs */
  int outsz_1[]={1,1,SCSREAL_N};
  int outsz_2[]={1,1,SCSREAL_N};
  int outsz_3[]={1,1,SCSREAL_N};
  int outsz_4[]={1,1,SCSREAL_N};
  int outsz_6[]={1,1,SCSREAL_N};

  void *outptr_1[]={0};
  void *outptr_2[]={0};
  void *outptr_3[]={0};
  void *outptr_4[]={0};
  void *outptr_5[]={0};
  void *outptr_6[]={0};

  /* Affectation of inptr */
  inptr_1[0] = (void *) outtb_3;
  inptr_2[0] = (void *) outtb_2;
  inptr_2[1] = (void *) outtb_5;
  inptr_4[0] = (void *) outtb_1;
  inptr_5[0] = (void *) outtb_4;
  inptr_6[0] = inptr[0];

  /* Affectation of outptr */
  outptr_1[0] = (void *) outtb_4;
  outptr_2[0] = (void *) outtb_3;
  outptr_3[0] = (void *) outtb_1;
  outptr_4[0] = (void *) outtb_2;
  outptr_5[0] = outptr[0];
  outptr_6[0] = (void *) outtb_5;

  /* set blk struc. of 'signum' (type 4 - blk nb 1) */
  block_SuperBlock[0].type    = 4;
  block_SuperBlock[0].ztyp    = 1;
  block_SuperBlock[0].ng      = 1;
  block_SuperBlock[0].nz      = 0;
  block_SuperBlock[0].nx      = 0;
  block_SuperBlock[0].noz     = 0;
  block_SuperBlock[0].nrpar   = 0;
  block_SuperBlock[0].nopar   = 0;
  block_SuperBlock[0].nipar   = 0;
  block_SuperBlock[0].nin     = 1;
  block_SuperBlock[0].nout    = 1;
  block_SuperBlock[0].nevout  = 0;
  block_SuperBlock[0].nmode   = 1;
  block_SuperBlock[0].inptr   = inptr_1;
  block_SuperBlock[0].insz    = insz_1;
  block_SuperBlock[0].outptr  = outptr_1;
  block_SuperBlock[0].outsz   = outsz_1;

  /* set blk struc. of 'summation' (type 4 - blk nb 2) */
  block_SuperBlock[1].type    = 4;
  block_SuperBlock[1].ztyp    = 0;
  block_SuperBlock[1].ng      = 0;
  block_SuperBlock[1].nz      = 0;
  block_SuperBlock[1].nx      = 0;
  block_SuperBlock[1].noz     = 0;
  block_SuperBlock[1].nrpar   = 1;
  block_SuperBlock[1].nopar   = 0;
  block_SuperBlock[1].nipar   = 2;
  block_SuperBlock[1].nin     = 2;
  block_SuperBlock[1].nout    = 1;
  block_SuperBlock[1].nevout  = 0;
  block_SuperBlock[1].nmode   = 0;
  block_SuperBlock[1].inptr   = inptr_2;
  block_SuperBlock[1].insz    = insz_2;
  block_SuperBlock[1].outptr  = outptr_2;
  block_SuperBlock[1].outsz   = outsz_2;
  block_SuperBlock[1].rpar    = rpar_2;
  block_SuperBlock[1].ipar    = ipar_2;

  /* set blk struc. of 'sawtth' (type 0 - blk nb 3) */
  block_SuperBlock[2].type    = 0;
  block_SuperBlock[2].ztyp    = 0;
  block_SuperBlock[2].ng      = 0;
  block_SuperBlock[2].nz      = 1;
  block_SuperBlock[2].nx      = 0;
  block_SuperBlock[2].noz     = 0;
  block_SuperBlock[2].nrpar   = 0;
  block_SuperBlock[2].nopar   = 0;
  block_SuperBlock[2].nipar   = 0;
  block_SuperBlock[2].nin     = 0;
  block_SuperBlock[2].nout    = 1;
  block_SuperBlock[2].nevout  = 0;
  block_SuperBlock[2].nmode   = 0;
  block_SuperBlock[2].outptr  = outptr_3;
  block_SuperBlock[2].outsz   = outsz_3;
  block_SuperBlock[2].z       = z_3;

  /* set blk struc. of 'gainblk' (type 4 - blk nb 4) */
  block_SuperBlock[3].type    = 4;
  block_SuperBlock[3].ztyp    = 0;
  block_SuperBlock[3].ng      = 0;
  block_SuperBlock[3].nz      = 0;
  block_SuperBlock[3].nx      = 0;
  block_SuperBlock[3].noz     = 0;
  block_SuperBlock[3].nrpar   = 1;
  block_SuperBlock[3].nopar   = 0;
  block_SuperBlock[3].nipar   = 0;
  block_SuperBlock[3].nin     = 1;
  block_SuperBlock[3].nout    = 1;
  block_SuperBlock[3].nevout  = 0;
  block_SuperBlock[3].nmode   = 0;
  block_SuperBlock[3].inptr   = inptr_4;
  block_SuperBlock[3].insz    = insz_4;
  block_SuperBlock[3].outptr  = outptr_4;
  block_SuperBlock[3].outsz   = outsz_4;
  block_SuperBlock[3].rpar    = rpar_4;

  /* set blk struc. of 'actionneur1' (type 0 - blk nb 5) */
  block_SuperBlock[4].type    = 0;
  block_SuperBlock[4].ztyp    = 0;
  block_SuperBlock[4].ng      = 0;
  block_SuperBlock[4].nz      = 0;
  block_SuperBlock[4].nx      = 0;
  block_SuperBlock[4].noz     = 0;
  block_SuperBlock[4].nrpar   = 0;
  block_SuperBlock[4].nopar   = 0;
  block_SuperBlock[4].nipar   = 1;
  block_SuperBlock[4].nin     = 1;
  block_SuperBlock[4].nout    = 0;
  block_SuperBlock[4].nevout  = 0;
  block_SuperBlock[4].nmode   = 0;
  block_SuperBlock[4].inptr   = inptr_5;
  block_SuperBlock[4].insz    = insz_5;
  block_SuperBlock[4].outptr  = outptr_5;
  block_SuperBlock[4].outsz   = &typout[0];
  block_SuperBlock[4].ipar    = ipar_5;

  /* set blk struc. of 'capteur1' (type 0 - blk nb 6) */
  block_SuperBlock[5].type    = 0;
  block_SuperBlock[5].ztyp    = 0;
  block_SuperBlock[5].ng      = 0;
  block_SuperBlock[5].nz      = 0;
  block_SuperBlock[5].nx      = 0;
  block_SuperBlock[5].noz     = 0;
  block_SuperBlock[5].nrpar   = 0;
  block_SuperBlock[5].nopar   = 0;
  block_SuperBlock[5].nipar   = 1;
  block_SuperBlock[5].nin     = 0;
  block_SuperBlock[5].nout    = 1;
  block_SuperBlock[5].nevout  = 0;
  block_SuperBlock[5].nmode   = 0;
  block_SuperBlock[5].inptr   = inptr_6;
  block_SuperBlock[5].insz    = &typin[0];
  block_SuperBlock[5].outptr  = outptr_6;
  block_SuperBlock[5].outsz   = outsz_6;
  block_SuperBlock[5].ipar    = ipar_6;

  /* set a variable to trace error of blocks */
  block_error=&err; /*GLOBAL*/

  /* set initial time */
  t=0.0;

  /* set initial phase simulation */
  phase=1;

  /* Initialization */

  /* Call of 'signum' (type 4 - blk nb 1 - with zcross) */
  block_SuperBlock[0].nevprt = 0;
  local_flag = 4;
  set_block_number(1);
  signum(&block_SuperBlock[0],local_flag);
  /* error handling */
  if (get_block_error() < 0) {
    set_block_error(5 - get_block_error());
  }

  /* Call of 'summation' (type 4 - blk nb 2) */
  block_SuperBlock[1].nevprt = 0;
  local_flag = 4;
  set_block_number(2);
  summation(&block_SuperBlock[1],local_flag);
  /* error handling */
  if (get_block_error() < 0) {
    set_block_error(5 - get_block_error());
  }

  /* Call of 'sawtth' (type 0 - blk nb 3) */
  block_SuperBlock[2].nevprt = 0;
  local_flag = 4;
  set_block_number(3);
  args[0]=NULL;
  args[1]=(double *)block_SuperBlock[2].outptr[0];
  C2F(sawtth)(&local_flag,&block_SuperBlock[2].nevprt,&t,block_SuperBlock[2].xd, \
              block_SuperBlock[2].x,&block_SuperBlock[2].nx, \
              block_SuperBlock[2].z,&block_SuperBlock[2].nz,block_SuperBlock[2].evout, \
              &block_SuperBlock[2].nevout,block_SuperBlock[2].rpar,&block_SuperBlock[2].nrpar, \
              block_SuperBlock[2].ipar,&block_SuperBlock[2].nipar, \
              (double *)args[0],(nrd_1=0,&nrd_1),(double *)args[1],(nrd_2=1,&nrd_2));
  /* error handling */
  if(local_flag < 0) {
    set_block_error(5 - local_flag);
  }

  /* Call of 'gainblk' (type 4 - blk nb 4) */
  block_SuperBlock[3].nevprt = 0;
  local_flag = 4;
  set_block_number(4);
  gainblk(&block_SuperBlock[3],local_flag);
  /* error handling */
  if (get_block_error() < 0) {
    set_block_error(5 - get_block_error());
  }

  /* Call of 'actionneur1' (type 0 - blk nb 5) */
  block_SuperBlock[4].nevprt = 0;
  local_flag = 4;
  set_block_number(5);
  nport = 1;
  SuperBlock_actuator(&local_flag, &nport, &block_SuperBlock[4].nevprt, \
                      &t, (SCSREAL_COP *)block_SuperBlock[4].inptr[0], \
                      &block_SuperBlock[4].insz[0], \
                      &block_SuperBlock[4].insz[1], \
                      &block_SuperBlock[4].insz[2], \
                      block_SuperBlock[4].outsz[0], \
                      block_SuperBlock[4].outptr[0]);
  /* error handling */
  if(local_flag < 0) {
    set_block_error(5 - local_flag);
  }

  /* Call of 'capteur1' (type 0 - blk nb 6) */
  block_SuperBlock[5].nevprt = 0;
  local_flag = 4;
  set_block_number(6);
  nport = 1;
  SuperBlock_sensor(&local_flag, &nport, &block_SuperBlock[5].nevprt, \
                    &t, (SCSREAL_COP *)block_SuperBlock[5].outptr[0], \
                    &block_SuperBlock[5].outsz[0], \
                    &block_SuperBlock[5].outsz[1], \
                    &block_SuperBlock[5].outsz[2], \
                    block_SuperBlock[5].insz[0], \
                    block_SuperBlock[5].inptr[0]);
  /* error handling */
  if(local_flag < 0) {
    set_block_error(5 - local_flag);
  }

  /* error handling */
  if (get_block_error() != 0) {
    SuperBlock_cosend();
    return get_block_error();
  }

  /* Initial blocks must be called with flag 1 */
  /* Call of 'sawtth' (type 0 - blk nb 3) */
  block_SuperBlock[2].nevprt = 0;
  local_flag = 1;
  set_block_number(3);
  args[0]=NULL;
  args[1]=(double *)block_SuperBlock[2].outptr[0];
  C2F(sawtth)(&local_flag,&block_SuperBlock[2].nevprt,&t,block_SuperBlock[2].xd, \
              block_SuperBlock[2].x,&block_SuperBlock[2].nx, \
              block_SuperBlock[2].z,&block_SuperBlock[2].nz,block_SuperBlock[2].evout, \
              &block_SuperBlock[2].nevout,block_SuperBlock[2].rpar,&block_SuperBlock[2].nrpar, \
              block_SuperBlock[2].ipar,&block_SuperBlock[2].nipar, \
              (double *)args[0],(nrd_1=0,&nrd_1),(double *)args[1],(nrd_2=1,&nrd_2));
  /* error handling */
  if(local_flag < 0) {
    set_block_error(5 - local_flag);
    SuperBlock_cosend();
    return get_block_error();
  }

  /* Call of 'gainblk' (type 4 - blk nb 4) */
  block_SuperBlock[3].nevprt = 1;
  local_flag = 1;
  set_block_number(4);
  gainblk(&block_SuperBlock[3],local_flag);
  /* error handling */
  if (get_block_error() < 0) {
    set_block_error(5 - get_block_error());
    SuperBlock_cosend();
    return get_block_error();
  }

  /* Call of 'capteur1' (type 0 - blk nb 6) */
  block_SuperBlock[5].nevprt = 0;
  local_flag = 1;
  set_block_number(6);
  nport = 1;
  SuperBlock_sensor(&local_flag, &nport, &block_SuperBlock[5].nevprt, \
                    &t, (SCSREAL_COP *)block_SuperBlock[5].outptr[0], \
                    &block_SuperBlock[5].outsz[0], \
                    &block_SuperBlock[5].outsz[1], \
                    &block_SuperBlock[5].outsz[2], \
                    block_SuperBlock[5].insz[0], \
                    block_SuperBlock[5].inptr[0]);
  /* error handling */
  if(local_flag < 0) {
    set_block_error(5 - local_flag);
    SuperBlock_cosend();
    return get_block_error();
  }

  /* Call of 'summation' (type 4 - blk nb 2) */
  block_SuperBlock[1].nevprt = 3;
  local_flag = 1;
  set_block_number(2);
  summation(&block_SuperBlock[1],local_flag);
  /* error handling */
  if (get_block_error() < 0) {
    set_block_error(5 - get_block_error());
    SuperBlock_cosend();
    return get_block_error();
  }

  /* Call of 'signum' (type 4 - blk nb 1 - with zcross) */
  block_SuperBlock[0].nevprt = 1;
  local_flag = 1;
  set_block_number(1);
  signum(&block_SuperBlock[0],local_flag);
  /* error handling */
  if (get_block_error() < 0) {
    set_block_error(5 - get_block_error());
    SuperBlock_cosend();
    return get_block_error();
  }

  /* Call of 'actionneur1' (type 0 - blk nb 5) */
  block_SuperBlock[4].nevprt = 1;
  local_flag = 1;
  set_block_number(5);
  nport = 1;
  SuperBlock_actuator(&local_flag, &nport, &block_SuperBlock[4].nevprt, \
                      &t, (SCSREAL_COP *)block_SuperBlock[4].inptr[0], \
                      &block_SuperBlock[4].insz[0], \
                      &block_SuperBlock[4].insz[1], \
                      &block_SuperBlock[4].insz[2], \
                      block_SuperBlock[4].outsz[0], \
                      block_SuperBlock[4].outptr[0]);
  /* error handling */
  if(local_flag < 0) {
    set_block_error(5 - local_flag);
    SuperBlock_cosend();
    return get_block_error();
  }


  while (t<=tf) {
    /* */
    scicos_time=t;

    /* Output computation */

    /* Blocks activated on the event number 0 */
    /* Call of 'sawtth' (type 0 - blk nb 3) */
    block_SuperBlock[2].nevprt = 0;
    local_flag = 1;
    set_block_number(3);
    args[0]=NULL;
    args[1]=(double *)block_SuperBlock[2].outptr[0];
    C2F(sawtth)(&local_flag,&block_SuperBlock[2].nevprt,&t,block_SuperBlock[2].xd, \
                block_SuperBlock[2].x,&block_SuperBlock[2].nx, \
                block_SuperBlock[2].z,&block_SuperBlock[2].nz,block_SuperBlock[2].evout, \
                &block_SuperBlock[2].nevout,block_SuperBlock[2].rpar,&block_SuperBlock[2].nrpar, \
                block_SuperBlock[2].ipar,&block_SuperBlock[2].nipar, \
                (double *)args[0],(nrd_1=0,&nrd_1),(double *)args[1],(nrd_2=1,&nrd_2));
    /* error handling */
    if(local_flag < 0) {
      set_block_error(5 - local_flag);
      SuperBlock_cosend();
      return get_block_error();
    }

    /* Call of 'gainblk' (type 4 - blk nb 4) */
    block_SuperBlock[3].nevprt = 1;
    local_flag = 1;
    set_block_number(4);
    gainblk(&block_SuperBlock[3],local_flag);
    /* error handling */
    if (get_block_error() < 0) {
      set_block_error(5 - get_block_error());
      SuperBlock_cosend();
      return get_block_error();
    }

    /* Call of 'capteur1' (type 0 - blk nb 6) */
    block_SuperBlock[5].nevprt = 0;
    local_flag = 1;
    set_block_number(6);
    nport = 1;
    SuperBlock_sensor(&local_flag, &nport, &block_SuperBlock[5].nevprt, \
                      &t, (SCSREAL_COP *)block_SuperBlock[5].outptr[0], \
                      &block_SuperBlock[5].outsz[0], \
                      &block_SuperBlock[5].outsz[1], \
                      &block_SuperBlock[5].outsz[2], \
                      block_SuperBlock[5].insz[0], \
                      block_SuperBlock[5].inptr[0]);
    /* error handling */
    if(local_flag < 0) {
      set_block_error(5 - local_flag);
      SuperBlock_cosend();
      return get_block_error();
    }

    /* Call of 'summation' (type 4 - blk nb 2) */
    block_SuperBlock[1].nevprt = 3;
    local_flag = 1;
    set_block_number(2);
    summation(&block_SuperBlock[1],local_flag);
    /* error handling */
    if (get_block_error() < 0) {
      set_block_error(5 - get_block_error());
      SuperBlock_cosend();
      return get_block_error();
    }

    /* Call of 'signum' (type 4 - blk nb 1 - with zcross) */
    block_SuperBlock[0].nevprt = 1;
    local_flag = 1;
    set_block_number(1);
    signum(&block_SuperBlock[0],local_flag);
    /* error handling */
    if (get_block_error() < 0) {
      set_block_error(5 - get_block_error());
      SuperBlock_cosend();
      return get_block_error();
    }

    /* Call of 'actionneur1' (type 0 - blk nb 5) */
    block_SuperBlock[4].nevprt = 1;
    local_flag = 1;
    set_block_number(5);
    nport = 1;
    SuperBlock_actuator(&local_flag, &nport, &block_SuperBlock[4].nevprt, \
                        &t, (SCSREAL_COP *)block_SuperBlock[4].inptr[0], \
                        &block_SuperBlock[4].insz[0], \
                        &block_SuperBlock[4].insz[1], \
                        &block_SuperBlock[4].insz[2], \
                        block_SuperBlock[4].outsz[0], \
                        block_SuperBlock[4].outptr[0]);
    /* error handling */
    if(local_flag < 0) {
      set_block_error(5 - local_flag);
      SuperBlock_cosend();
      return get_block_error();
    }

    /* Discrete activations */
    switch (nevprt) {
      case 1 : /* Blocks activated on the event number 1 */
        /* Call of 'sawtth' (type 0 - blk nb 3) */
        block_SuperBlock[2].nevprt = 1;
        local_flag = 1;
        set_block_number(3);
        args[0]=NULL;
        args[1]=(double *)block_SuperBlock[2].outptr[0];
        C2F(sawtth)(&local_flag,&block_SuperBlock[2].nevprt,&t,block_SuperBlock[2].xd, \
                    block_SuperBlock[2].x,&block_SuperBlock[2].nx, \
                    block_SuperBlock[2].z,&block_SuperBlock[2].nz,block_SuperBlock[2].evout, \
                    &block_SuperBlock[2].nevout,block_SuperBlock[2].rpar,&block_SuperBlock[2].nrpar, \
                    block_SuperBlock[2].ipar,&block_SuperBlock[2].nipar, \
                    (double *)args[0],(nrd_1=0,&nrd_1),(double *)args[1],(nrd_2=1,&nrd_2));
        /* error handling */
        if(local_flag < 0) {
          set_block_error(5 - local_flag);
          SuperBlock_cosend();
          return get_block_error();
        }
    
        /* Call of 'gainblk' (type 4 - blk nb 4) */
        block_SuperBlock[3].nevprt = 1;
        local_flag = 1;
        set_block_number(4);
        gainblk(&block_SuperBlock[3],local_flag);
        /* error handling */
        if (get_block_error() < 0) {
          set_block_error(5 - get_block_error());
          SuperBlock_cosend();
          return get_block_error();
        }
    
        /* Call of 'capteur1' (type 0 - blk nb 6) */
        block_SuperBlock[5].nevprt = 1;
        local_flag = 1;
        set_block_number(6);
        nport = 1;
        SuperBlock_sensor(&local_flag, &nport, &block_SuperBlock[5].nevprt, \
                          &t, (SCSREAL_COP *)block_SuperBlock[5].outptr[0], \
                          &block_SuperBlock[5].outsz[0], \
                          &block_SuperBlock[5].outsz[1], \
                          &block_SuperBlock[5].outsz[2], \
                          block_SuperBlock[5].insz[0], \
                          block_SuperBlock[5].inptr[0]);
        /* error handling */
        if(local_flag < 0) {
          set_block_error(5 - local_flag);
          SuperBlock_cosend();
          return get_block_error();
        }
    
        /* Call of 'summation' (type 4 - blk nb 2) */
        block_SuperBlock[1].nevprt = 3;
        local_flag = 1;
        set_block_number(2);
        summation(&block_SuperBlock[1],local_flag);
        /* error handling */
        if (get_block_error() < 0) {
          set_block_error(5 - get_block_error());
          SuperBlock_cosend();
          return get_block_error();
        }
    
        /* Call of 'signum' (type 4 - blk nb 1 - with zcross) */
        block_SuperBlock[0].nevprt = 1;
        local_flag = 1;
        set_block_number(1);
        signum(&block_SuperBlock[0],local_flag);
        /* error handling */
        if (get_block_error() < 0) {
          set_block_error(5 - get_block_error());
          SuperBlock_cosend();
          return get_block_error();
        }
    
        /* Call of 'actionneur1' (type 0 - blk nb 5) */
        block_SuperBlock[4].nevprt = 1;
        local_flag = 1;
        set_block_number(5);
        nport = 1;
        SuperBlock_actuator(&local_flag, &nport, &block_SuperBlock[4].nevprt, \
                            &t, (SCSREAL_COP *)block_SuperBlock[4].inptr[0], \
                            &block_SuperBlock[4].insz[0], \
                            &block_SuperBlock[4].insz[1], \
                            &block_SuperBlock[4].insz[2], \
                            block_SuperBlock[4].outsz[0], \
                            block_SuperBlock[4].outptr[0]);
        /* error handling */
        if(local_flag < 0) {
          set_block_error(5 - local_flag);
          SuperBlock_cosend();
          return get_block_error();
        }
    
      break;

    }
    /* Discrete state computation */
    /* Discrete activations */
    switch (nevprt) {
      case 1 : /* Blocks activated on the event number 1 */
        /* Call of 'sawtth' (type 0 - blk nb 3) */
        block_SuperBlock[2].nevprt = 1;
        local_flag = 2;
        set_block_number(3);
        args[0]=NULL;
        args[1]=(double *)block_SuperBlock[2].outptr[0];
        C2F(sawtth)(&local_flag,&block_SuperBlock[2].nevprt,&t,block_SuperBlock[2].xd, \
                    block_SuperBlock[2].x,&block_SuperBlock[2].nx, \
                    block_SuperBlock[2].z,&block_SuperBlock[2].nz,block_SuperBlock[2].evout, \
                    &block_SuperBlock[2].nevout,block_SuperBlock[2].rpar,&block_SuperBlock[2].nrpar, \
                    block_SuperBlock[2].ipar,&block_SuperBlock[2].nipar, \
                    (double *)args[0],(nrd_1=0,&nrd_1),(double *)args[1],(nrd_2=1,&nrd_2));
        /* error handling */
        if(local_flag < 0) {
          set_block_error(5 - local_flag);
          SuperBlock_cosend();
          return get_block_error();
        }
    
        /* Call of 'actionneur1' (type 0 - blk nb 5) */
        block_SuperBlock[4].nevprt = 1;
        local_flag = 2;
        set_block_number(5);
        nport = 1;
        SuperBlock_actuator(&local_flag, &nport, &block_SuperBlock[4].nevprt, \
                            &t, (SCSREAL_COP *)block_SuperBlock[4].inptr[0], \
                            &block_SuperBlock[4].insz[0], \
                            &block_SuperBlock[4].insz[1], \
                            &block_SuperBlock[4].insz[2], \
                            block_SuperBlock[4].outsz[0], \
                            block_SuperBlock[4].outptr[0]);
        /* error handling */
        if(local_flag < 0) {
          set_block_error(5 - local_flag);
          SuperBlock_cosend();
          return get_block_error();
        }
    
      break;

    }

    /* update current time */
    t=t+dt;

    /* set phase simulation */
    phase=1;
  }

  SuperBlock_cosend();
  return get_block_error();
}
/*---------------------------------------- Cosend function */
int SuperBlock_cosend()
{
  /* local variables used to call block */
  int local_flag,i;
  int nport;

  /* Variables for constant values */
  int nrd_1, nrd_2;
  double *args[100];

  double t;

  /* get scicos_time */
  t = scicos_time;

  /* Ending */

  /* Call of 'signum' (type 4 - blk nb 1 - with zcross) */
  block_SuperBlock[0].nevprt = 0;
  local_flag = 5;
  set_block_number(1);
  signum(&block_SuperBlock[0],local_flag);
  /* error handling */
  if (get_block_error() < 0) {
    set_block_error(5 - get_block_error());
  }

  /* Call of 'summation' (type 4 - blk nb 2) */
  block_SuperBlock[1].nevprt = 0;
  local_flag = 5;
  set_block_number(2);
  summation(&block_SuperBlock[1],local_flag);
  /* error handling */
  if (get_block_error() < 0) {
    set_block_error(5 - get_block_error());
  }

  /* Call of 'sawtth' (type 0 - blk nb 3) */
  block_SuperBlock[2].nevprt = 0;
  local_flag = 5;
  set_block_number(3);
  args[0]=NULL;
  args[1]=(double *)block_SuperBlock[2].outptr[0];
  C2F(sawtth)(&local_flag,&block_SuperBlock[2].nevprt,&t,block_SuperBlock[2].xd, \
              block_SuperBlock[2].x,&block_SuperBlock[2].nx, \
              block_SuperBlock[2].z,&block_SuperBlock[2].nz,block_SuperBlock[2].evout, \
              &block_SuperBlock[2].nevout,block_SuperBlock[2].rpar,&block_SuperBlock[2].nrpar, \
              block_SuperBlock[2].ipar,&block_SuperBlock[2].nipar, \
              (double *)args[0],(nrd_1=0,&nrd_1),(double *)args[1],(nrd_2=1,&nrd_2));
  /* error handling */
  if(local_flag < 0) {
    set_block_error(5 - local_flag);
  }

  /* Call of 'gainblk' (type 4 - blk nb 4) */
  block_SuperBlock[3].nevprt = 0;
  local_flag = 5;
  set_block_number(4);
  gainblk(&block_SuperBlock[3],local_flag);
  /* error handling */
  if (get_block_error() < 0) {
    set_block_error(5 - get_block_error());
  }

  /* Call of 'actionneur1' (type 0 - blk nb 5) */
  block_SuperBlock[4].nevprt = 0;
  local_flag = 5;
  set_block_number(5);
  nport = 1;
  SuperBlock_actuator(&local_flag, &nport, &block_SuperBlock[4].nevprt, \
                      &t, (SCSREAL_COP *)block_SuperBlock[4].inptr[0], \
                      &block_SuperBlock[4].insz[0], \
                      &block_SuperBlock[4].insz[1], \
                      &block_SuperBlock[4].insz[2], \
                      block_SuperBlock[4].outsz[0], \
                      block_SuperBlock[4].outptr[0]);
  /* error handling */
  if(local_flag < 0) {
    set_block_error(5 - local_flag);
  }

  /* Call of 'capteur1' (type 0 - blk nb 6) */
  block_SuperBlock[5].nevprt = 0;
  local_flag = 5;
  set_block_number(6);
  nport = 1;
  SuperBlock_sensor(&local_flag, &nport, &block_SuperBlock[5].nevprt, \
                    &t, (SCSREAL_COP *)block_SuperBlock[5].outptr[0], \
                    &block_SuperBlock[5].outsz[0], \
                    &block_SuperBlock[5].outsz[1], \
                    &block_SuperBlock[5].outsz[2], \
                    block_SuperBlock[5].insz[0], \
                    block_SuperBlock[5].inptr[0]);
  /* error handling */
  if(local_flag < 0) {
    set_block_error(5 - local_flag);
  }

  /* return block_error */
  return get_block_error();
}


/*----------------------------------------  Lapack messag function */
void C2F(xerbla)(SRNAME,INFO,L)
     char *SRNAME;
     int *INFO;
     long int L;
{
  printf("** On entry to %s, parameter number %d"
         "  had an illegal value\n",SRNAME,*INFO);
}

void set_block_error(int err)
{
  *block_error = err;
  return;
}

int get_block_error()
{
  return *block_error;
}

void set_block_number(int kfun)
{
  block_number = kfun;
  return;
}

int get_block_number()
{
  return block_number;
}

int get_phase_simulation()
{
  return phase;
}

void * scicos_malloc(size_t size)
{
  return malloc(size);
}

void scicos_free(void *p)
{
  free(p);
}

double get_scicos_time()
{
  return scicos_time;
}

void do_cold_restart()
{
  return;
}

void sciprint (char *fmt)
{
  return;
}

#if WIN32
 #ifndef vsnprintf
   #define vsnprintf _vsnprintf
 #endif
#endif

#ifdef __STDC__
void Coserror (char *fmt,...)
#else
void Coserror(va_alist) va_dcl
#endif
{
 int retval;
 va_list ap;

#ifdef __STDC__
 va_start(ap,fmt);
#else

 char *fmt;
 va_start(ap);

 fmt = va_arg(ap, char *);
#endif

#if defined (vsnprintf) || defined (linux)
 retval= vsnprintf(err_msg,4095, fmt, ap);
#else
 retval= vsprintf(err_msg,fmt, ap);
#endif

 if (retval == -1) {
   err_msg[0]='\0';
 }

 va_end(ap);

 /* coserror use error number 10 */
 *block_error=-5;

 return;
}

int getopt (int argc, char *argv[], char *optstring)
{
  char *group, option, *sopt;
  char *optarg;
  int len;
  int offset = 0;
  option = -1;
  optarg = NULL;
  while ( optind < argc )
    { 
      group = argv[optind];
      if ( *group != '-' )
        {
         option = -1;
         optarg = group;
         optind++;
         break;
        }
      len = strlen (group);
      group = group + offset;
      if ( *group == '-' )
        {
         group++;
         offset += 2;
        }
      else
        offset++ ;
      option = *group ;
      sopt = strchr ( optstring, option ) ;
      if ( sopt != NULL )
        {
         sopt++ ;
         if ( *sopt == ':' )
           {
             optarg = group + 1;
             if ( *optarg == '\0' )
                optarg = argv[++optind];
             if ( *optarg == '-' )
                {
                 fprintf ( stderr, "%s: illegal option -- %c \n",
                           argv[0], option );
                 option = '?';
                 break;
                }
             else
                {
                 optind++;
                 offset = 0;
                 break;
                }
           }
         if ( offset >= len )
           {
             optind++;
             offset = 0;
           }
         break;
        }
      else
        {
         fprintf ( stderr, "%s: illegal option -- %c \n", argv[0], option );
         option = '?';
         break;
        }
    }
  return ( option );
}

