/* Code for actuators/sensors to be used in generic interfacing functions */
/*     Generated by Code_Generation toolbox of Scicos with scicos4.4 */
/*     date : 20-Oct-2010 */

/* Copyright (c) 1989-2010 Metalau project INRIA */

/* ---- Headers ---- */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "stack-c.h"
#include "mex.h"
#include <scicos/scicos.h>

/* structure definition of in/out sensors/actuators */
typedef struct {
  int typ;      /* data type */
  int ndims;    /* number of dims */
  int ndata;    /* number of data */
  int *dims;    /* size of data (length ndims) */
  double *time; /* date of data (length ndata) */
  void *data;   /* data (length ndata*prod(dims)) */
} scicos_inout;

/*---------------------------------------- Actuators */
void SuperBlock_dummy_actuator(flag,nport,nevprt,t,typout,outptr)
     int *flag,*nevprt,*nport;

     int typout;
     void *outptr;

     double *t;
{
  /* declaration of scicos_inout variable for output of actuator */
  scicos_inout *out;

  /* static counter variable */
  static int cnt_1;
  int cnt=0;

  /* update cnt */
  if(*nport==1) {
    cnt=cnt_1;
  }

  /* affectation of output structure of actuators*/
  out=(scicos_inout *)outptr;

  switch (*flag) {

    case 4 : /* actuator initialisation */
      /* initialisation of counter variable */
      cnt=0;
      break;

    case 1 :
      out->time[cnt]=*t;
      /*fprintf(stderr,"actuator %d : cnt = %d\n",*nport,cnt);*/
      /* increase counter variable */
      /*fprintf(stderr,"out->ndata=%d\n",out->ndata);*/
      cnt++;

      /* check and realloc out->data/out->time if needed */
      if (cnt==out->ndata) {
        out->ndata=2*out->ndata;
        if ((out->time = (double *) realloc(out->time, \
             out->ndata*sizeof(double)))==NULL) {
          set_block_error(-16);
          return;
        }
      }
    case 5 : /* actuator ending */
      out->ndata=cnt;
      break;
  }

  /* update cnt */
  if(*nport==1) {
    cnt_1=cnt;
  }
}

/*---------------------------------------- Actuators */
void SuperBlock_actuator(flag,nport,nevprt,t,u,nu1,nu2,ut,typout,outptr)
     int *flag,*nevprt,*nport;
     int *nu1,*nu2,*ut;

     int typout;
     void *outptr;

     double *t;
     void *u;
{
  /*int k,l;*/
  /* declaration of scicos_inout variable for output of actuator */
  scicos_inout *out;

  /* static counter variable */
  static int cnt_1;
  int cnt=0;

  /* update cnt */
  if(*nport==1) {
    cnt=cnt_1;
  }

  /* affectation of output structure of actuators*/
  out=(scicos_inout *)outptr;

  switch (*flag) {

    case 4 : /* actuator initialisation */
      /* initialisation of counter variable */
      cnt=0;
      break;

    case 1 :
      switch (*ut) {
      case 10 :
        memcpy(((double *) out->data + cnt*(*nu1)*(*nu2)), \
               ((double *) u), (*nu1)*(*nu2)*sizeof(double));
        /* *((double *) out->data + cnt)=*((double *) u); */
        out->time[cnt]=*t;
        /*fprintf(stderr,"actuator %d : cnt = %d\n",*nport,cnt);*/
        break;

      case 11 :
        memcpy(((double *) out->data + cnt*(*nu1)*(*nu2)), \
               ((double *) u), (*nu1)*(*nu2)*sizeof(double));
        memcpy(((double *) out->data + cnt*(*nu1)*(*nu2) + out->ndata), \
               ((double *) u + (*nu1)*(*nu2)), (*nu1)*(*nu2)*sizeof(double));
        out->time[cnt]=*t;
        break;

      case 81 :
        break;

      case 82 :
        break;

      case 84 :
        break;

      case 811 :
        break;

      case 812 :
        break;

      case 814 :
        break;
      }

      /* increase counter variable */
      /*fprintf(stderr,"out->ndata=%d\n",out->ndata);*/
      cnt++;

      /* check and realloc out->data/out->time if needed */
      if (cnt==out->ndata) {
        out->ndata=2*out->ndata;
        if ((*ut)==11) {
          if ((out->data = (double *) realloc(out->data, \
               out->ndata*(*nu1)*(*nu2)*2*sizeof(double)))==NULL) {
            set_block_error(-16);
            return;
          }
          memcpy(((double *) out->data + (out->ndata/2)*(*nu1)*(*nu2)), \
                 ((double *) out->data + out->ndata*(*nu1)*(*nu2)), \
                  (out->ndata/2)*(*nu1)*(*nu2)*sizeof(double));
        }
        else {
          if ((out->data = (double *) realloc(out->data, \
               out->ndata*(*nu1)*(*nu2)*sizeof(double)))==NULL) {
            set_block_error(-16);
            return;
          }
        }
        if ((out->time = (double *) realloc(out->time, \
             out->ndata*sizeof(double)))==NULL) {
          set_block_error(-16);
          return;
        }
      }
      break;

    case 5 : /* actuator ending */
      switch (*ut) {
        case 11 :
          memcpy(((double *) out->data + (cnt)*(*nu1)*(*nu2)), \
                 ((double *) out->data + out->ndata*(*nu1)*(*nu2)), \
                  (cnt)*(*nu1)*(*nu2)*sizeof(double));
      }
      out->ndata=cnt;
      break;
  }

  /* update cnt */
  if(*nport==1) {
    cnt_1=cnt;
  }
}

/*---------------------------------------- Sensors */
void SuperBlock_sensor(flag,nport,nevprt,t,y,ny1,ny2,yt,typin,inptr)
     int *flag,*nevprt,*nport;
     int *ny1,*ny2,*yt;

     int typin;
     void *inptr;

     double *t;
     void *y;
{
  /*int k,l;*/
  /* declaration of scicos_inout variable for input of sensors */
  scicos_inout *in;

  /* static counter variable */
  static int cnt_1;
  int cnt=0;

  /* */
  if (get_phase_simulation()!=1) {
    return;
  }

  /* update cnt */
  if(*nport==1) {
    cnt=cnt_1;
  }
  /* affectation of intput structure of sensors */
  in=(scicos_inout *)inptr;

  switch (*flag) {

    case 4 : /* sensor initialisation */
      /* initialisation of counter variable */
      cnt=0;
      break;

    case 1 :
      switch (*yt) {
      case 10 :
        memcpy((double *) y, \
              ((double *) in->data + cnt*(*ny1)*(*ny2)), \
              (*ny1)*(*ny2)*sizeof(double));
        /* *((double *)y)=*((double *)in->data + cnt); */
        /*fprintf(stderr,"sensor %d : cnt = %d\n",*nport,cnt);*/
        break;

      case 11 :
        memcpy((double *) y, \
              ((double *) in->data + cnt*(*ny1)*(*ny2)), \
              (*ny1)*(*ny2)*sizeof(double));
        memcpy((double *) y+(*ny1)*(*ny2), \
              ((double *) in->data + cnt*(*ny1)*(*ny2)) + (*ny1)*(*ny2)*in->ndata, \
              (*ny1)*(*ny2)*sizeof(double));
        break;

      case 81 :
        break;

      case 82 :
        break;

      case 84 :
        break;

      case 811 :
        break;

      case 812 :
        break;

      case 814 :
        break;
      }

      /* increase counter variables */
      cnt++;

      /* check value of cnt */
      if (cnt==in->ndata) {
        cnt--;
      }
      break;

    case 5 : /* sensor ending */
      break;
  }

  /* update cnt */
  if(*nport==1) {
    cnt_1=cnt;
  }
}
